#!/usr/bin/bash

#usage:
#  backupserver.sh

#see: https://www.ostricher.com/2014/10/the-right-way-to-get-the-directory-of-a-bash-script/
SOURCE="${BASH_SOURCE[0]}"
while [ -h "$SOURCE" ]; do
  DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
  SOURCE="$( readlink "$SOURCE" )"
  [[ $SOURCE != /* ]] && SOURCE="$DIR/$SOURCE"
done
DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"

cd ~diaspora

MARIAPASSWORD=`grep -v '#' diaspora/config/database.yml | grep password | grep -v '""' | awk '{print $2}' | sed 's#"##g'`

if [ ! -d "backups" ]
then
  mkdir backups
fi

TIMESTAMP=`date +%Y%m%d%H%M%S`

if [ ! -d "backups/${TIMESTAMP}" ]
then
  mkdir backups/${TIMESTAMP}
fi

cd backups/${TIMESTAMP}
cp -pR ~/diaspora ./

mkdir mysql
cd mysql

mysqldump -u root -p${MARIAPASSWORD} -l > mysql.sql
mysqldump -u root -p${MARIAPASSWORD} -l information_schema > information_schema.sql
mysqldump -u root -p${MARIAPASSWORD} -l performance_schema > performance_schema.sql
mysqldump -u root -p${MARIAPASSWORD} -l diaspora_production > diaspora_production.sql

cd ~diaspora/backups

tar -zcvf ${TIMESTAMP}.tgz ${TIMESTAMP}
rm -rf ${TIMESTAMP}

find . -name "*.tgz" -ctime +5 | xargs rm -f